##################################################################
# Unipro UGENE - Integrated Bioinformatics Suite
# Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
# All Rights Reserved
# 
#
#     This source code is distributed under the terms of the
#     GNU General Public License. See the files COPYING and LICENSE
#     for details.
##################################################################

include (umuscle4.pri)

# Input
HEADERS += src/Muscle4Plugin.h \
	   src/Muscle4Task.h \
	   src/Muscle4TaskLocalStorage.h \
	   src/Muscle4Context.h \
	   src/Muscle4Tests.h \
           src/Muscle4Adapter.h \
	   src/Muscle4Worker.h \
 	   src/muscle4/best.h \
 	   src/muscle4/hit.h \
 	   src/muscle4/info.h \
 	   src/muscle4/isgap.h \
 	   src/muscle4/models.h \
 	   src/muscle4/mx.h \
 	   src/muscle4/myopts.h \
 	   src/muscle4/myutils.h \
 	   src/muscle4/params.h \ 
 	   src/muscle4/regex.h \
 	   src/muscle4/seqdb.h \
 	   src/muscle4/sparsemx.h \
 	   src/muscle4/sumlog.h \
 	   src/muscle4/svnrevision.h \
 	   src/muscle4/transopts.h \
 	   src/muscle4/transparams.h \
 	   src/muscle4/tree.h

SOURCES += src/Muscle4Plugin.cpp \
	   src/Muscle4Task.cpp \
	   src/Muscle4TaskLocalStorage.cpp \
	   src/Muscle4Context.cpp \
	   src/Muscle4Tests.cpp \
	   src/Muscle4Adapter.cpp \
	   src/Muscle4Worker.cpp \
 	   src/muscle4/accmx.cpp \
 	   src/muscle4/addseqs.cpp \
 	   src/muscle4/align.cpp \
 	   src/muscle4/alignmaf.cpp \
 	   src/muscle4/alignmasked.cpp \
 	   src/muscle4/alignseqtomsa.cpp \
 	   src/muscle4/aligntwomsas.cpp \
 	   src/muscle4/alnseq.cpp \
 	   src/muscle4/blosum70c.cpp \
 	   src/muscle4/bwdfull.cpp \
 	   src/muscle4/bwdswcrf.cpp \
 	   src/muscle4/cartoons.cpp \
 	   src/muscle4/codon.cpp \
 	   src/muscle4/colprobs.cpp \
 	   src/muscle4/cons.cpp \
 	   src/muscle4/fasta.cpp \
 	   src/muscle4/fastglob.cpp \
 	   src/muscle4/fwdbwd.cpp \
 	   src/muscle4/fwdbwdfull.cpp \
 	   src/muscle4/fwdbwdsw.cpp \
 	   src/muscle4/fwdfull.cpp \
 	   src/muscle4/fwdswcrf.cpp \
	   src/muscle4/getunsegs.cpp \
	   src/muscle4/guidetree.cpp \
	   src/muscle4/inverts.cpp \
	   src/muscle4/iterfb.cpp \
	   src/muscle4/loglocalaln.cpp \
	   src/muscle4/loglocalalnaln.cpp \
	   src/muscle4/loglocalalnx.cpp \
	   src/muscle4/logmaccs.cpp \
	   src/muscle4/logmsa.cpp \
	   src/muscle4/models.cpp \
	   src/muscle4/msacartoon.cpp \
	   src/muscle4/multilocal.cpp \
	   src/muscle4/multisw.cpp \
	   src/muscle4/multiswx.cpp \
	   src/muscle4/mus4_main.cpp \
	   src/muscle4/mx.cpp \
	   src/muscle4/myutils.cpp \
	   src/muscle4/nucmx.cpp \
	   src/muscle4/params.cpp \
	   src/muscle4/pccrfmx.cpp \
	   src/muscle4/pcparamsda.cpp \
	   src/muscle4/pcrnamx.cpp \
	   src/muscle4/postproc.cpp \
	   src/muscle4/profile.cpp \
	   src/muscle4/progalign.cpp \
	   src/muscle4/prune.cpp \
	   src/muscle4/refine.cpp \
	   src/muscle4/regex.cpp \
	   src/muscle4/repeats.cpp \
	   src/muscle4/rowprobs.cpp \
	   src/muscle4/self.cpp \
	   src/muscle4/selfaln.cpp \
	   src/muscle4/seqdb.cpp \
	   src/muscle4/seqweights.cpp \
	   src/muscle4/simmx.cpp \
	   src/muscle4/sparsemx.cpp \
	   src/muscle4/spps.cpp \
	   src/muscle4/substmx.cpp \
	   src/muscle4/sw.cpp \
	   src/muscle4/swaff.cpp \
	   src/muscle4/testsw.cpp \
	   src/muscle4/tree.cpp \
	   src/muscle4/valcov.cpp \
	   src/muscle4/viterbi.cpp \
	   src/muscle4/xlat.cpp 
TRANSLATIONS += transl/english.ts transl/russian.ts
